-- == SRB2Randomizer: Ring patterns ==
-- Entire file is dedicated to the massive amount of ring patterns I have defined

-- NORMAL PATTERNS
randomizer.randomRingPatterns = {}

-- 3x1 row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 0},
	[2] = {x = 64, y = 0, z = 0},
	[3] = {x = -64, y = 0, z = 0},
})

-- 4x1 row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 32, y = 0, z = 0},
	[2] = {x = -32, y = 0, z = 0},
	[3] = {x = 96, y = 0, z = 0},
	[4] = {x = -96, y = 0, z = 0},
})

-- 5x1 row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 0},
	[2] = {x = 64, y = 0, z = 0},
	[3] = {x = -64, y = 0, z = 0},
	[4] = {x = 128, y = 0, z = 0},
	[5] = {x = -128, y = 0, z = 0},
})

-- 6x1 row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 32, y = 0, z = 0},
	[2] = {x = -32, y = 0, z = 0},
	[3] = {x = 96, y = 0, z = 0},
	[4] = {x = -96, y = 0, z = 0},
	[5] = {x = 160, y = 0, z = 0},
	[6] = {x = -160, y = 0, z = 0},
})

-- 7x1 row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 0},
	[2] = {x = 64, y = 0, z = 0},
	[3] = {x = -64, y = 0, z = 0},
	[4] = {x = 128, y = 0, z = 0},
	[5] = {x = -128, y = 0, z = 0},
	[6] = {x = 192, y = 0, z = 0},
	[7] = {x = -192, y = 0, z = 0},
})

-- 8x1 row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 32, y = 0, z = 0},
	[2] = {x = -32, y = 0, z = 0},
	[3] = {x = 96, y = 0, z = 0},
	[4] = {x = -96, y = 0, z = 0},
	[5] = {x = 160, y = 0, z = 0},
	[6] = {x = -160, y = 0, z = 0},
	[7] = {x = 224, y = 0, z = 0},
	[8] = {x = -224, y = 0, z = 0},
})

-- 10x1 row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 32, y = 0, z = 0},
	[2] = {x = -32, y = 0, z = 0},
	[3] = {x = 96, y = 0, z = 0},
	[4] = {x = -96, y = 0, z = 0},
	[5] = {x = 160, y = 0, z = 0},
	[6] = {x = -160, y = 0, z = 0},
	[7] = {x = 224, y = 0, z = 0},
	[8] = {x = -224, y = 0, z = 0},
	[9] = {x = 288, y = 0, z = 0},
	[10] = {x = -288, y = 0, z = 0},
})

-- 3x1 raised row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 72},
	[2] = {x = 64, y = 0, z = 72},
	[3] = {x = -64, y = 0, z = 72},
})

-- 4x1 raised row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 32, y = 0, z = 72},
	[2] = {x = -32, y = 0, z = 72},
	[3] = {x = 96, y = 0, z = 72},
	[4] = {x = -96, y = 0, z = 72},
})

-- 5x1 raised row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 72},
	[2] = {x = 64, y = 0, z = 72},
	[3] = {x = -64, y = 0, z = 72},
	[4] = {x = 128, y = 0, z = 72},
	[5] = {x = -128, y = 0, z = 72},
})

-- 3x1 jump arc
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 72},
	[2] = {x = 64, y = 0, z = 56},
	[3] = {x = -64, y = 0, z = 56},
})

-- 4x1 jump arc
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 32, y = 0, z = 80},
	[2] = {x = -32, y = 0, z = 80},
	[3] = {x = 96, y = 0, z = 64},
	[4] = {x = -96, y = 0, z = 64},
})

-- 5x1 jump arc
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 80},
	[2] = {x = 64, y = 0, z = 72},
	[3] = {x = -64, y = 0, z = 72},
	[4] = {x = 128, y = 0, z = 56},
	[5] = {x = -128, y = 0, z = 56},
})

-- 3x2 row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 32, z = 0},
	[2] = {x = 64, y = 32, z = 0},
	[3] = {x = -64, y = 32, z = 0},
	[4] = {x = 0, y = -32, z = 0},
	[5] = {x = 64, y = -32, z = 0},
	[6] = {x = -64, y = -32, z = 0},
})

-- 5x2 row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 32, z = 0},
	[2] = {x = 64, y = 32, z = 0},
	[3] = {x = -64, y = 32, z = 0},
	[4] = {x = 128, y = 32, z = 0},
	[5] = {x = -128, y = 32, z = 0},
	[6] = {x = 0, y = -32, z = 0},
	[7] = {x = 64, y = -32, z = 0},
	[8] = {x = -64, y = -32, z = 0},
	[9] = {x = 128, y = -32, z = 0},
	[10] = {x = -128, y = -32, z = 0},
})

-- 7x2 row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 32, z = 0},
	[2] = {x = 64, y = 32, z = 0},
	[3] = {x = -64, y = 32, z = 0},
	[4] = {x = 128, y = 32, z = 0},
	[5] = {x = -128, y = 32, z = 0},
	[6] = {x = 192, y = 32, z = 0},
	[7] = {x = -192, y = 32, z = 0},
	[8] = {x = 0, y = -32, z = 0},
	[9] = {x = 64, y = -32, z = 0},
	[10] = {x = -64, y = -32, z = 0},
	[11] = {x = 128, y = -32, z = 0},
	[12] = {x = -128, y = -32, z = 0},
	[13] = {x = 192, y = -32, z = 0},
	[14] = {x = -192, y = -32, z = 0},
})

-- 10x2 row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 32, y = 32, z = 0},
	[2] = {x = -32, y = 32, z = 0},
	[3] = {x = 96, y = 32, z = 0},
	[4] = {x = -96, y = 32, z = 0},
	[5] = {x = 160, y = 32, z = 0},
	[6] = {x = -160, y = 32, z = 0},
	[7] = {x = 224, y = 32, z = 0},
	[8] = {x = -224, y = 32, z = 0},
	[9] = {x = 288, y = 32, z = 0},
	[10] = {x = 288, y = 32, z = 0},
	[11] = {x = 32, y = -32, z = 0},
	[12] = {x = -32, y = -32, z = 0},
	[13] = {x = 96, y = -32, z = 0},
	[14] = {x = -96, y = -32, z = 0},
	[15] = {x = 160, y = -32, z = 0},
	[16] = {x = -160, y = -32, z = 0},
	[17] = {x = 224, y = -32, z = 0},
	[18] = {x = -224, y = -32, z = 0},
	[19] = {x = 288, y = -32, z = 0},
	[20] = {x = -288, y = -32, z = 0},
})

-- 3x2 offset row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 32, y = 32, z = 0},
	[2] = {x = -32, y = 32, z = 0},
	[3] = {x = 96, y = 32, z = 0},
	[4] = {x = 32, y = -32, z = 0},
	[5] = {x = -32, y = -32, z = 0},
	[6] = {x = -96, y = -32, z = 0},
})

-- 5x2 offset row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 32, y = 32, z = 0},
	[2] = {x = -32, y = 32, z = 0},
	[3] = {x = 96, y = 32, z = 0},
	[4] = {x = -96, y = 32, z = 0},
	[5] = {x = 160, y = 32, z = 0},
	[6] = {x = 32, y = -32, z = 0},
	[7] = {x = -32, y = -32, z = 0},
	[8] = {x = 96, y = -32, z = 0},
	[9] = {x = -96, y = -32, z = 0},
	[10] = {x = -160, y = -32, z = 0},
})

-- 7x2 offset row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 32, y = 32, z = 0},
	[2] = {x = -32, y = 32, z = 0},
	[3] = {x = 96, y = 32, z = 0},
	[4] = {x = -96, y = 32, z = 0},
	[5] = {x = 160, y = 32, z = 0},
	[6] = {x = -160, y = 32, z = 0},
	[7] = {x = 224, y = 32, z = 0},
	[8] = {x = 32, y = -32, z = 0},
	[9] = {x = -32, y = -32, z = 0},
	[10] = {x = 96, y = -32, z = 0},
	[11] = {x = -96, y = -32, z = 0},
	[12] = {x = 160, y = -32, z = 0},
	[13] = {x = -160, y = -32, z = 0},
	[14] = {x = -224, y = -32, z = 0},
})

-- 5x3 row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 0},
	[2] = {x = 64, y = 0, z = 0},
	[3] = {x = -64, y = 0, z = 0},
	[4] = {x = 128, y = 0, z = 0},
	[5] = {x = -128, y = 0, z = 0},
	[6] = {x = 0, y = 64, z = 0},
	[7] = {x = 64, y = 64, z = 0},
	[8] = {x = -64, y = 64, z = 0},
	[9] = {x = 128, y = 64, z = 0},
	[10] = {x = -128, y = 64, z = 0},
	[11] = {x = 0, y = -64, z = 0},
	[12] = {x = 64, y = -64, z = 0},
	[13] = {x = -64, y = -64, z = 0},
	[14] = {x = 128, y = -64, z = 0},
	[15] = {x = -128, y = -64, z = 0},
})

-- 7x3 row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 0},
	[2] = {x = 64, y = 0, z = 0},
	[3] = {x = -64, y = 0, z = 0},
	[4] = {x = 128, y = 0, z = 0},
	[5] = {x = -128, y = 0, z = 0},
	[6] = {x = 192, y = 0, z = 0},
	[7] = {x = -192, y = 0, z = 0},
	[8] = {x = 0, y = 64, z = 0},
	[9] = {x = 64, y = 64, z = 0},
	[10] = {x = -64, y = 64, z = 0},
	[11] = {x = 128, y = 64, z = 0},
	[12] = {x = -128, y = 64, z = 0},
	[13] = {x = 192, y = 64, z = 0},
	[14] = {x = -192, y = 64, z = 0},
	[15] = {x = 0, y = 64, z = 0},
	[16] = {x = 64, y = 64, z = 0},
	[17] = {x = -64, y = 64, z = 0},
	[18] = {x = 128, y = 64, z = 0},
	[19] = {x = -128, y = 64, z = 0},
	[20] = {x = 192, y = 64, z = 0},
	[21] = {x = -192, y = 64, z = 0},
})

-- 10x3 row
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 32, y = 0, z = 0},
	[2] = {x = -32, y = 0, z = 0},
	[3] = {x = 96, y = 0, z = 0},
	[4] = {x = -96, y = 0, z = 0},
	[5] = {x = 160, y = 0, z = 0},
	[6] = {x = -160, y = 0, z = 0},
	[7] = {x = 224, y = 0, z = 0},
	[8] = {x = -224, y = 0, z = 0},
	[9] = {x = 288, y = 0, z = 0},
	[10] = {x = -288, y = 0, z = 0},
	[11] = {x = 32, y = 64, z = 0},
	[12] = {x = -32, y = 64, z = 0},
	[13] = {x = 96, y = 64, z = 0},
	[14] = {x = -96, y = 64, z = 0},
	[15] = {x = 160, y = 64, z = 0},
	[16] = {x = -160, y = 64, z = 0},
	[17] = {x = 224, y = 64, z = 0},
	[18] = {x = -224, y = 64, z = 0},
	[19] = {x = 288, y = 64, z = 0},
	[20] = {x = -288, y = 64, z = 0},
	[21] = {x = 32, y = -64, z = 0},
	[22] = {x = -32, y = -64, z = 0},
	[23] = {x = 96, y = -64, z = 0},
	[24] = {x = -96, y = -64, z = 0},
	[25] = {x = 160, y = -64, z = 0},
	[26] = {x = -160, y = -64, z = 0},
	[27] = {x = 224, y = -64, z = 0},
	[28] = {x = -224, y = -64, z = 0},
	[29] = {x = 288, y = -64, z = 0},
	[30] = {x = -288, y = -64, z = 0},
})

-- 8-ring circle
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 64, y = 0, z = 0},
	[2] = {x = 48, y = 48, z = 0},
	[3] = {x = 0, y = 64, z = 0},
	[4] = {x = -48, y = 48, z = 0},
	[5] = {x = -64, y = 0, z = 0},
	[6] = {x = -48, y = -48, z = 0},
	[7] = {x = 0, y = -64, z = 0},
	[8] = {x = 48, y = -48, z = 0},
})

-- 16-ring circle
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 128, y = 0, z = 0},
	[2] = {x = 120, y = 48, z = 0},
	[3] = {x = 88, y = 88, z = 0},
	[4] = {x = 48, y = 120, z = 0},
	[5] = {x = 0, y = 128, z = 0},
	[6] = {x = -48, y = 120, z = 0},
	[7] = {x = -88, y = 88, z = 0},
	[8] = {x = -120, y = 48, z = 0},
	[9] = {x = -128, y = 0, z = 0},
	[10] = {x = -120, y = -48, z = 0},
	[11] = {x = -88, y = -88, z = 0},
	[12] = {x = -48, y = -120, z = 0},
	[13] = {x = 0, y = -128, z = 0},
	[14] = {x = 48, y = -120, z = 0},
	[15] = {x = 88, y = -88, z = 0},
	[16] = {x = 120, y = -48, z = 0},
})

-- 2x2 square
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 32, y = 32, z = 0},
	[2] = {x = 32, y = -32, z = 0},
	[3] = {x = -32, y = 32, z = 0},
	[4] = {x = -32, y = -32, z = 0},
})

-- 3x3 square
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 0},
	[2] = {x = 64, y = 0, z = 0},
	[3] = {x = -64, y = 0, z = 0},
	[4] = {x = 0, y = 64, z = 0},
	[5] = {x = 64, y = 64, z = 0},
	[6] = {x = -64, y = 64, z = 0},
	[7] = {x = 0, y = -64, z = 0},
	[8] = {x = 64, y = -64, z = 0},
	[9] = {x = -64, y = -4, z = 0},
})

-- 4x4 square
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 32, y = 32, z = 0},
	[2] = {x = 32, y = -32, z = 0},
	[3] = {x = 32, y = 96, z = 0},
	[4] = {x = 32, y = -96, z = 0},
	[5] = {x = -32, y = 32, z = 0},
	[6] = {x = -32, y = -32, z = 0},
	[7] = {x = -32, y = 96, z = 0},
	[8] = {x = -32, y = -96, z = 0},
	[9] = {x = 96, y = 32, z = 0},
	[10] = {x = 96, y = -32, z = 0},
	[11] = {x = 96, y = 96, z = 0},
	[12] = {x = 96, y = -96, z = 0},
	[13] = {x = -96, y = 32, z = 0},
	[14] = {x = -96, y = -32, z = 0},
	[15] = {x = -96, y = 96, z = 0},
	[16] = {x = -96, y = -96, z = 0},
})

-- 5x5 square
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 0},
	[2] = {x = 64, y = 0, z = 0},
	[3] = {x = -64, y = 0, z = 0},
	[4] = {x = 128, y = 0, z = 0},
	[5] = {x = -128, y = 0, z = 0},
	[6] = {x = 0, y = 64, z = 0},
	[7] = {x = 64, y = 64, z = 0},
	[8] = {x = -64, y = 64, z = 0},
	[9] = {x = 128, y = 64, z = 0},
	[10] = {x = -128, y = 64, z = 0},
	[11] = {x = 0, y = -64, z = 0},
	[12] = {x = 64, y = -64, z = 0},
	[13] = {x = -64, y = -64, z = 0},
	[14] = {x = 128, y = -64, z = 0},
	[15] = {x = -128, y = -64, z = 0},
	[16] = {x = 0, y = 128, z = 0},
	[17] = {x = 64, y = 128, z = 0},
	[18] = {x = -64, y = 128, z = 0},
	[19] = {x = 128, y = 128, z = 0},
	[20] = {x = -128, y = 128, z = 0},
	[21] = {x = 0, y = -128, z = 0},
	[22] = {x = 64, y = -128, z = 0},
	[23] = {x = -64, y = -128, z = 0},
	[24] = {x = 128, y = -128, z = 0},
	[25] = {x = -128, y = -128, z = 0},
})

-- 3x3 empty square
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 64, z = 0},
	[2] = {x = 0, y = -64, z = 0},
	[3] = {x = 64, y = 0, z = 0},
	[4] = {x = 64, y = 64, z = 0},
	[5] = {x = 64, y = -64, z = 0},
	[6] = {x = -64, y = 0, z = 0},
	[7] = {x = -64, y = 64, z = 0},
	[8] = {x = -64, y = -64, z = 0},
})

-- 4x4 empty square
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 96, y = 96, z = 0},
	[2] = {x = 96, y = 32, z = 0},
	[3] = {x = 96, y = -32, z = 0},
	[4] = {x = 96, y = -96, z = 0},
	[5] = {x = -96, y = 96, z = 0},
	[6] = {x = -96, y = 32, z = 0},
	[7] = {x = -96, y = -32, z = 0},
	[8] = {x = -96, y = -96, z = 0},
	[9] = {x = 32, y = 96, z = 0},
	[10] = {x = 32, y = -96, z = 0},
	[11] = {x = -32, y = 96, z = 0},
	[12] = {x = -32, y = -96, z = 0},
})

-- 5x5 empty square
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 128, y = 0, z = 0},
	[2] = {x = 128, y = 64, z = 0},
	[3] = {x = 128, y = -64, z = 0},
	[4] = {x = 128, y = 128, z = 0},
	[5] = {x = 128, y = -128, z = 0},
	[6] = {x = -128, y = 0, z = 0},
	[7] = {x = -128, y = 64, z = 0},
	[8] = {x = -128, y = -64, z = 0},
	[9] = {x = -128, y = 128, z = 0},
	[10] = {x = -128, y = -128, z = 0},
	[11] = {x = 0, y = 128, z = 0},
	[12] = {x = 0, y = -128, z = 0},
	[13] = {x = 64, y = 128, z = 0},
	[14] = {x = 64, y = -128, z = 0},
	[15] = {x = -64, y = 128, z = 0},
	[16] = {x = -64, y = -128, z = 0},
})

-- 3x3 hexagon
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 0},
	[2] = {x = 64, y = 0, z = 0},
	[3] = {x = -64, y = 0, z = 0},
	[4] = {x = -32, y = 64, z = 0},
	[5] = {x = 32, y = 64, z = 0},
	[6] = {x = -32, y = -64, z = 0},
	[7] = {x = 32, y = -64, z = 0},
})

-- 5x3 hexagon
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 0},
	[2] = {x = 64, y = 0, z = 0},
	[3] = {x = -64, y = 0, z = 0},
	[4] = {x = 128, y = 0, z = 0},
	[5] = {x = -128, y = 0, z = 0},
	[6] = {x = -32, y = 64, z = 0},
	[7] = {x = 32, y = 64, z = 0},
	[8] = {x = -96, y = 64, z = 0},
	[9] = {x = 96, y = 64, z = 0},
	[10] = {x = -32, y = -64, z = 0},
	[11] = {x = 32, y = -64, z = 0},
	[12] = {x = -96, y = -64, z = 0},
	[13] = {x = 96, y = -64, z = 0},
})

-- 5x5 hexagon
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 0},
	[2] = {x = 64, y = 0, z = 0},
	[3] = {x = -64, y = 0, z = 0},
	[4] = {x = 128, y = 0, z = 0},
	[5] = {x = -128, y = 0, z = 0},
	[6] = {x = -32, y = 64, z = 0},
	[7] = {x = 32, y = 64, z = 0},
	[8] = {x = -96, y = 64, z = 0},
	[9] = {x = 96, y = 64, z = 0},
	[10] = {x = -32, y = -64, z = 0},
	[11] = {x = 32, y = -64, z = 0},
	[12] = {x = -96, y = -64, z = 0},
	[13] = {x = 96, y = -64, z = 0},
	[14] = {x = 0, y = 128, z = 0},
	[15] = {x = 64, y = 128, z = 0},
	[16] = {x = -64, y = 128, z = 0},
	[17] = {x = 0, y = -128, z = 0},
	[18] = {x = 64, y = -128, z = 0},
	[19] = {x = -64, y = -128, z = 0},
})

-- 2x2 X
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 0},
	[2] = {x = 64, y = 64, z = 0},
	[3] = {x = -64, y = 64, z = 0},
	[4] = {x = 64, y = -64, z = 0},
	[5] = {x = -64, y = -64, z = 0},
})

-- 3x3 X
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 0},
	[2] = {x = 64, y = 64, z = 0},
	[3] = {x = -64, y = 64, z = 0},
	[4] = {x = 64, y = -64, z = 0},
	[5] = {x = -64, y = -64, z = 0},
	[6] = {x = 128, y = 128, z = 0},
	[7] = {x = -128, y = 128, z = 0},
	[8] = {x = 128, y = -128, z = 0},
	[9] = {x = -128, y = -128, z = 0},
})

-- 4x4 X
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 0},
	[2] = {x = 64, y = 64, z = 0},
	[3] = {x = -64, y = 64, z = 0},
	[4] = {x = 64, y = -64, z = 0},
	[5] = {x = -64, y = -64, z = 0},
	[6] = {x = 128, y = 128, z = 0},
	[7] = {x = -128, y = 128, z = 0},
	[8] = {x = 128, y = -128, z = 0},
	[9] = {x = -128, y = -128, z = 0},
	[10] = {x = 192, y = 192, z = 0},
	[11] = {x = -192, y = 192, z = 0},
	[12] = {x = 192, y = -192, z = 0},
	[13] = {x = -192, y = -192, z = 0},
})

-- 3x3 triangle
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 0},
	[2] = {x = 64, y = 0, z = 0},
	[3] = {x = -64, y = 0, z = 0},
	[4] = {x = 0, y = 64, z = 0},
	[5] = {x = 0, y = -64, z = 0},
	[6] = {x = 64, y = -64, z = 0},
	[7] = {x = -64, y = -64, z = 0},
	[8] = {x = 128, y = -64, z = 0},
	[9] = {x = -128, y = -64, z = 0},
})

-- 5x5 triangle
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 0},
	[2] = {x = 64, y = 0, z = 0},
	[3] = {x = -64, y = 0, z = 0},
	[4] = {x = 128, y = 0, z = 0},
	[5] = {x = -128, y = 0, z = 0},
	[6] = {x = 0, y = 64, z = 0},
	[7] = {x = 64, y = 64, z = 0},
	[8] = {x = -64, y = 64, z = 0},
	[9] = {x = 0, y = 128, z = 0},
	[10] = {x = 0, y = -64, z = 0},
	[11] = {x = 64, y = -64, z = 0},
	[12] = {x = -64, y = -64, z = 0},
	[13] = {x = 128, y = -64, z = 0},
	[14] = {x = -128, y = -64, z = 0},
	[15] = {x = 192, y = -64, z = 0},
	[16] = {x = -192, y = -64, z = 0},
	[17] = {x = 0, y = -128, z = 0},
	[18] = {x = 64, y = -128, z = 0},
	[19] = {x = -64, y = -128, z = 0},
	[20] = {x = 128, y = -128, z = 0},
	[21] = {x = -128, y = -128, z = 0},
	[22] = {x = 192, y = -128, z = 0},
	[23] = {x = -192, y = -128, z = 0},
	[24] = {x = 256, y = -128, z = 0},
	[25] = {x = -256, y = -128, z = 0},
})

-- Small cluster
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 0},
	[2] = {x = 64, y = 0, z = 0},
	[3] = {x = -64, y = 0, z = 0},
	[4] = {x = 0, y = 64, z = 0},
	[5] = {x = 0, y = -64, z = 0},
	[6] = {x = 0, y = 0, z = 48},
})

-- Large cluster
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 0, y = 0, z = 0},
	[2] = {x = 64, y = 64, z = 0},
	[3] = {x = 64, y = -64, z = 0},
	[4] = {x = -64, y = 64, z = 0},
	[5] = {x = -64, y = -64, z = 0},
	[6] = {x = 0, y = 64, z = 48},
	[7] = {x = 0, y = -64, z = 48},
	[8] = {x = 64, y = 64, z = 48},
	[9] = {x = 64, y = -64, z = 48},
	[10] = {x = -64, y = 64, z = 48},
	[11] = {x = -64, y = -64, z = 48},
	[12] = {x = 0, y = 0, z = 96},
	[13] = {x = 0, y = 64, z = 96},
	[14] = {x = 0, y = -64, z = 96},
	[15] = {x = 64, y = 0, z = 96},
	[16] = {x = -64, y = 0, z = 96},
})

-- x1 snake A
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = -64, y = 256, z = 0},
	[2] = {x = -48, y = 192, z = 0},
	[3] = {x = 0, y = 128, z = 0},
	[4] = {x = 48, y = 64, z = 0},
	[5] = {x = 64, y = 0, z = 0},
	[6] = {x = 48, y = -64, z = 0},
	[7] = {x = 0, y = -128, z = 0},
	[8] = {x = -48, y = -192, z = 0},
	[9] = {x = -64, y = -256, z = 0},
})

-- x1 snake B
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 64, y = 256, z = 0},
	[2] = {x = 48, y = 192, z = 0},
	[3] = {x = 0, y = 128, z = 0},
	[4] = {x = -48, y = 64, z = 0},
	[5] = {x = -64, y = 0, z = 0},
	[6] = {x = -48, y = -64, z = 0},
	[7] = {x = 0, y = -128, z = 0},
	[8] = {x = 48, y = -192, z = 0},
	[9] = {x = 64, y = -256, z = 0},
})

-- x2 snake A
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = -96, y = 256, z = 0},
	[2] = {x = -80, y = 192, z = 0},
	[3] = {x = -32, y = 128, z = 0},
	[4] = {x = 16, y = 64, z = 0},
	[5] = {x = 32, y = 0, z = 0},
	[6] = {x = 16, y = -64, z = 0},
	[7] = {x = -32, y = -128, z = 0},
	[8] = {x = -80, y = -192, z = 0},
	[9] = {x = -96, y = -256, z = 0},
	[10] = {x = -32, y = 256, z = 0},
	[11] = {x = -16, y = 192, z = 0},
	[12] = {x = 32, y = 128, z = 0},
	[13] = {x = 80, y = 64, z = 0},
	[14] = {x = 96, y = 0, z = 0},
	[15] = {x = 80, y = -64, z = 0},
	[16] = {x = 32, y = -128, z = 0},
	[17] = {x = -16, y = -192, z = 0},
	[18] = {x = -32, y = -256, z = 0},
})

-- x2 snake B
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 32, y = 256, z = 0},
	[2] = {x = 16, y = 192, z = 0},
	[3] = {x = -32, y = 128, z = 0},
	[4] = {x = -80, y = 64, z = 0},
	[5] = {x = -96, y = 0, z = 0},
	[6] = {x = -80, y = -64, z = 0},
	[7] = {x = -32, y = -128, z = 0},
	[8] = {x = 16, y = -192, z = 0},
	[9] = {x = 32, y = -256, z = 0},
	[10] = {x = 96, y = 256, z = 0},
	[11] = {x = 80, y = 192, z = 0},
	[12] = {x = 32, y = 128, z = 0},
	[13] = {x = -16, y = 64, z = 0},
	[14] = {x = -32, y = 0, z = 0},
	[15] = {x = -16, y = -64, z = 0},
	[16] = {x = 32, y = -128, z = 0},
	[17] = {x = 80, y = -192, z = 0},
	[18] = {x = 96, y = -256, z = 0},
})

-- 2x2 elbow
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 32, y = 32, z = 0},
	[2] = {x = 32, y = -32, z = 0},
	[3] = {x = -32, y = 32, z = 0},
})

-- 3x3 elbow
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 64, y = 64, z = 0},
	[2] = {x = 64, y = 0, z = 0},
	[3] = {x = 64, y = -64, z = 0},
	[4] = {x = 0, y = -64, z = 0},
	[5] = {x = -64, y = -64, z = 0},
})

-- 4x4 elbow
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 96, y = 96, z = 0},
	[2] = {x = 96, y = 32, z = 0},
	[3] = {x = 96, y = -32, z = 0},
	[4] = {x = 96, y = -96, z = 0},
	[5] = {x = 32, y = -96, z = 0},
	[6] = {x = -32, y = -96, z = 0},
	[7] = {x = -96, y = -96, z = 0},
})

-- 5x5 elbow
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 128, y = 128, z = 0},
	[2] = {x = 128, y = 64, z = 0},
	[3] = {x = 128, y = 0, z = 0},
	[4] = {x = 128, y = -64, z = 0},
	[5] = {x = 128, y = -128, z = 0},
	[6] = {x = 64, y = -128, z = 0},
	[7] = {x = 0, y = -128, z = 0},
	[8] = {x = -64, y = -128, z = 0},
	[9] = {x = -128, y = -128, z = 0},
})

-- Small octagon
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 96, y = 32, z = 0},
	[2] = {x = 96, y = -32, z = 0},
	[3] = {x = -96, y = 32, z = 0},
	[4] = {x = -96, y = -32, z = 0},
	[5] = {x = 32, y = 96, z = 0},
	[6] = {x = 32, y = -96, z = 0},
	[7] = {x = -32, y = 96, z = 0},
	[8] = {x = -32, y = -96, z = 0},
})

-- Large octagon
table.insert(randomizer.randomRingPatterns, {
	[1] = {x = 192, y = 0, z = 0},
	[2] = {x = 192, y = 64, z = 0},
	[3] = {x = 192, y = -64, z = 0},
	[4] = {x = -192, y = 0, z = 0},
	[5] = {x = -192, y = 64, z = 0},
	[6] = {x = -192, y = -64, z = 0},
	[7] = {x = 0, y = 192, z = 0},
	[8] = {x = 0, y = -192, z = 0},
	[9] = {x = 64, y = 192, z = 0},
	[10] = {x = 64, y = -192, z = 0},
	[11] = {x = -64, y = 192, z = 0},
	[12] = {x = -64, y = -192, z = 0},
	[13] = {x = 128, y = 128, z = 0},
	[14] = {x = 128, y = -128, z = 0},
	[15] = {x = -128, y = 128, z = 0},
	[16] = {x = -128, y = -128, z = 0},
})

-- VERTICAL SPRING PATTERNS
randomizer.randomVSpringPatterns = {}

-- Stack of 3x1
table.insert(randomizer.randomVSpringPatterns, {
	[1] = {x = 0, y = 0, z = 72},
	[2] = {x = 0, y = 0, z = 168},
	[3] = {x = 0, y = 0, z = 264},
})

-- Stack of 5x1
table.insert(randomizer.randomVSpringPatterns, {
	[1] = {x = 0, y = 0, z = 40},
	[2] = {x = 0, y = 0, z = 104},
	[3] = {x = 0, y = 0, z = 168},
	[4] = {x = 0, y = 0, z = 232},
	[5] = {x = 0, y = 0, z = 296},
})

-- Stack of 7x1
table.insert(randomizer.randomVSpringPatterns, {
	[1] = {x = 0, y = 0, z = 20},
	[2] = {x = 0, y = 0, z = 64},
	[3] = {x = 0, y = 0, z = 108},
	[4] = {x = 0, y = 0, z = 152},
	[5] = {x = 0, y = 0, z = 196},
	[6] = {x = 0, y = 0, z = 240},
	[7] = {x = 0, y = 0, z = 284},
})

-- Stack of 10x1
table.insert(randomizer.randomVSpringPatterns, {
	[1] = {x = 0, y = 0, z = 8},
	[2] = {x = 0, y = 0, z = 40},
	[3] = {x = 0, y = 0, z = 72},
	[4] = {x = 0, y = 0, z = 104},
	[5] = {x = 0, y = 0, z = 136},
	[6] = {x = 0, y = 0, z = 168},
	[7] = {x = 0, y = 0, z = 200},
	[8] = {x = 0, y = 0, z = 232},
	[9] = {x = 0, y = 0, z = 264},
	[10] = {x = 0, y = 0, z = 296},
})

-- Stack of 3x4
table.insert(randomizer.randomVSpringPatterns, {
	[1] = {x = 24, y = 24, z = 72},
	[2] = {x = 24, y = 24, z = 168},
	[3] = {x = 24, y = 24, z = 264},
	[4] = {x = 24, y = -24, z = 72},
	[5] = {x = 24, y = -24, z = 168},
	[6] = {x = 24, y = -24, z = 264},
	[7] = {x = -24, y = 24, z = 72},
	[8] = {x = -24, y = 24, z = 168},
	[9] = {x = -24, y = 24, z = 264},
	[10] = {x = -24, y = -24, z = 72},
	[11] = {x = -24, y = -24, z = 168},
	[12] = {x = -24, y = -24, z = 264},
})

-- Stack of 5x4
table.insert(randomizer.randomVSpringPatterns, {
	[1] = {x = 24, y = 24, z = 40},
	[2] = {x = 24, y = 24, z = 104},
	[3] = {x = 24, y = 24, z = 168},
	[4] = {x = 24, y = 24, z = 232},
	[5] = {x = 24, y = 24, z = 296},
	[6] = {x = 24, y = -24, z = 40},
	[7] = {x = 24, y = -24, z = 104},
	[8] = {x = 24, y = -24, z = 168},
	[9] = {x = 24, y = -24, z = 232},
	[10] = {x = 24, y = -24, z = 296},
	[11] = {x = -24, y = 24, z = 40},
	[12] = {x = -24, y = 24, z = 104},
	[13] = {x = -24, y = 24, z = 168},
	[14] = {x = -24, y = 24, z = 232},
	[15] = {x = -24, y = 24, z = 296},
	[16] = {x = -24, y = -24, z = 40},
	[17] = {x = -24, y = -24, z = 104},
	[18] = {x = -24, y = -24, z = 168},
	[19] = {x = -24, y = -24, z = 232},
	[20] = {x = -24, y = -24, z = 296},
})

-- DIAGONAL SPRING PATTERNS
randomizer.randomDSpringPatterns = {}

-- 3x1 diagonal row
table.insert(randomizer.randomDSpringPatterns, {
	[1] = {x = 96, y = 0, z = 72},
	[2] = {x = 192, y = 0, z = 168},
	[3] = {x = 288, y = 0, z = 264},
})

-- 5x1 diagonal row
table.insert(randomizer.randomDSpringPatterns, {
	[1] = {x = 64, y = 0, z = 40},
	[2] = {x = 128, y = 0, z = 104},
	[3] = {x = 192, y = 0, z = 168},
	[4] = {x = 256, y = 0, z = 232},
	[5] = {x = 320, y = 0, z = 296},
})

-- 7x1 diagonal row
table.insert(randomizer.randomDSpringPatterns, {
	[1] = {x = 44, y = 0, z = 20},
	[2] = {x = 88, y = 0, z = 64},
	[3] = {x = 132, y = 0, z = 108},
	[4] = {x = 176, y = 0, z = 152},
	[5] = {x = 220, y = 0, z = 196},
	[6] = {x = 264, y = 0, z = 240},
	[7] = {x = 308, y = 0, z = 284},
})

-- 10x1 diagonal row
table.insert(randomizer.randomDSpringPatterns, {
	[1] = {x = 32, y = 0, z = 8},
	[2] = {x = 64, y = 0, z = 40},
	[3] = {x = 96, y = 0, z = 72},
	[4] = {x = 128, y = 0, z = 104},
	[5] = {x = 160, y = 0, z = 136},
	[6] = {x = 192, y = 0, z = 168},
	[7] = {x = 224, y = 0, z = 200},
	[8] = {x = 256, y = 0, z = 232},
	[9] = {x = 288, y = 0, z = 264},
	[10] = {x = 320, y = 0, z = 296},
})
